Summary:         Utility to access BitLocker encrypted volumes
Name:            dislocker
Version:         0.7.3
Release:    2%{?dist}
License:         GPL-2.0-or-later
URL:             https://github.com/Aorimn/dislocker
Source0:         https://github.com/Aorimn/dislocker/archive/v%{version}/%{name}-%{version}.tar.gz
Patch0:          dislocker-0.7.3-duplicate-variable-name.patch
Requires:        %{name}-libs = %{version}-%{release}
Requires:        ruby(release)
Requires:        ruby(runtime_executable)
Requires(post):  %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives
Provides:        %{_bindir}/%{name}
BuildRequires:   gcc
BuildRequires:   cmake
BuildRequires:   mbedtls-devel
BuildRequires:   ruby-devel
BuildRequires:   %{_bindir}/ruby

%description
Dislocker has been designed to read BitLocker encrypted partitions ("drives")
under a Linux system. The driver has the capability to read/write partitions
encrypted using Microsoft Windows Vista, 7, 8, 8.1 and 10 (AES-CBC, AES-XTS,
128 or 256 bits, with or without the Elephant diffuser, encrypted partitions);
BitLocker-To-Go encrypted partitions (USB/FAT32 partitions).

The file name where the BitLocker encrypted partition will be decrypted needs
to be given. This may take a long time, depending on the size of the encrypted
partition. But afterward, once the partition is decrypted, the access to the
NTFS partition will be faster than with FUSE. Another thing to think about is
the size of the disk (same size as the volume that is tried to be decrypted).
Nevertheless, once the partition is decrypted, the file can be mounted as any
NTFS partition and won't have any link to the original BitLocker partition.

%package libs
Summary:         Libraries for applications using dislocker

%description libs
The dislocker-libs package provides the essential shared libraries for any
dislocker client program or interface.

%package -n fuse-dislocker
Summary:         FUSE filesystem to access BitLocker encrypted volumes
Provides:        %{_bindir}/%{name}
Provides:        dislocker-fuse = %{version}-%{release}
Provides:        dislocker-fuse = %{version}-%{release}
Requires:        %{name}-libs = %{version}-%{release}
Requires(post):  %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives
BuildRequires:   fuse-devel

%description -n fuse-dislocker
Dislocker has been designed to read BitLocker encrypted partitions ("drives")
under a Linux system. The driver has the capability to read/write partitions
encrypted using Microsoft Windows Vista, 7, 8, 8.1 and 10 (AES-CBC, AES-XTS,
128 or 256 bits, with or without the Elephant diffuser, encrypted partitions);
BitLocker-To-Go encrypted partitions (USB/FAT32 partitions).

A mount point needs to be given to dislocker-fuse. Once keys are decrypted, a
file named 'dislocker-file' appears into this provided mount point. This file
is a virtual NTFS partition, it can be mounted as any NTFS partition and then
reading from it or writing to it is possible.

%prep
%setup -q
%patch0 -p1 -b .duplicate

%build
%cmake -D WARN_FLAGS="-Wall -Wno-error -Wextra"
%cmake_build

%install
%cmake_install

rm -f %{buildroot}{%{_bindir}/%{name},%{_mandir}/man1/%{name}.1*}

for file in *.md; do mv -f $file ${file%.md}; done
for file in *.txt; do mv -f $file ${file%.txt}; done

%post
%{_sbindir}/alternatives --install %{_bindir}/%{name} %{name} %{_bindir}/%{name}-file 60

%preun
if [ $1 -eq 0 ]; then
  %{_sbindir}/alternatives --remove %{name} %{_bindir}/%{name}-file
fi


%post -n fuse-dislocker
%{_sbindir}/alternatives --install %{_bindir}/%{name} %{name} %{_bindir}/%{name}-fuse 80

%preun -n fuse-dislocker
if [ $1 -eq 0 ]; then
  %{_sbindir}/alternatives --remove %{name} %{_bindir}/%{name}-fuse
fi

%files
%{_bindir}/%{name}-bek
%{_bindir}/%{name}-file
%{_bindir}/%{name}-find
%{_bindir}/%{name}-metadata
%{_mandir}/man1/%{name}-file.1*
%{_mandir}/man1/%{name}-find.1*

%files libs
%license LICENSE
%doc CHANGELOG README
%{_libdir}/libdislocker.so.*
%{_libdir}/libdislocker.so

%files -n fuse-dislocker
%{_bindir}/%{name}-fuse
%{_mandir}/man1/%{name}-fuse.1*

%changelog
* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 0.7.3-2
- epol debrand

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.7.3-1
- initial build
